# coding: utf-8

"""
/*
 Copyright 2019 IBM Corp.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at
 http://www.apache.org/licenses/LICENSE-2.0
 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

"""

import pprint
import re  # noqa: F401

import six
#from ibm_security_advisor_findings_api_client.models.big_decimal import BigDecimal  # noqa: F401,E501

from decimal import *

class Kpi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value': 'BigDecimal',
        'total': 'BigDecimal'
    }

    attribute_map = {
        'value': 'value',
        'total': 'total'
    }

    def __init__(self, value=None, total=None):  # noqa: E501
        """Kpi - a model defined in Swagger"""  # noqa: E501
        self._value = None
        self._total = None
        self.discriminator = None
        self.value = value
        if total is not None:
            self.total = total

    @property
    def value(self):
        """Gets the value of this Kpi.  # noqa: E501

        The value of this KPI  # noqa: E501

        :return: The value of this Kpi.  # noqa: E501
        :rtype: BigDecimal
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this Kpi.

        The value of this KPI  # noqa: E501

        :param value: The value of this Kpi.  # noqa: E501
        :type: BigDecimal
        """
        if value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def total(self):
        """Gets the total of this Kpi.  # noqa: E501

        The total value of this KPI  # noqa: E501

        :return: The total of this Kpi.  # noqa: E501
        :rtype: BigDecimal
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this Kpi.

        The total value of this KPI  # noqa: E501

        :param total: The total of this Kpi.  # noqa: E501
        :type: BigDecimal
        """

        self._total = total

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Kpi, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Kpi):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
